/*
 *
 * nvgpu sim support
 *
 * Copyright (c) 2018-2023, NVIDIA CORPORATION.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU General Public License,
 * version 2, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SIM_LINUX_H__
#define __SIM_LINUX_H__

struct platform_device;
struct gk20a_platform;

struct sim_nvgpu_linux {
	struct sim_nvgpu sim;
	struct resource *reg_mem;
	void (*remove_support_linux)(struct gk20a *g);
};

int nvgpu_init_sim_support_linux(struct gk20a *g,
		struct platform_device *dev);
int nvgpu_init_sim_support_linux_igpu_pci(struct gk20a *g,
		struct gk20a_platform *platform);
void nvgpu_remove_sim_support_linux(struct gk20a *g);
#endif
